<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row v-if="!editMode">
    <v-col cols="12" md="12">
      <v-card>
        <v-card-title>
          Datenschutzerklärungen
          <v-spacer />
          <v-btn
            class="mx-2"
            fab
            small
            :color="util.CONFIG.MAIN_BAR_COLOR"
            @click="editMode = true"
            :disabled="loading || !isLatestValid()"
            :dark="!(loading || !isLatestValid())"
            ><v-icon>mdi-plus</v-icon></v-btn
          >
        </v-card-title>
        <v-card-subtitle v-if="!loading">
          <span v-if="!isLatestValid()" class="red--text"
            >Die aktuellste Datenschutzerklärung ist noch nicht gültig. Es kann zurzeit keine neue
            angelegt werden.<br
          /></span>
        </v-card-subtitle>
        <v-snackbar
          v-if="applicationStore.session.user.permissions.includes('ADMIN')"
          v-model="snackbar.show"
          :color="snackbar.failure ? 'error' : 'success'"
          top
          multi-line
          vertical
        >
          <div>
            {{ snackbar.message }}
          </div>
        </v-snackbar>

        <v-data-table
          :headers="headers"
          :items="documents"
          :loading="loading"
          disable-sort
          single-expand
          show-expand
        >
          <template v-slot:expanded-item="{ headers, item }">
            <td :colspan="headers.length" class="pa-4">
              <Editor mode="viewer" :outline="false" v-model="item.content" />
            </td>
          </template>
        </v-data-table>
      </v-card>
    </v-col>

    <v-col v-if="!editMode && latestGdpr" cols="12" md="12">
      <v-card>
        <v-card-title>
          Zustimmungen zur Datenschutzerklärung Version {{ latestGdpr.id }}
          <v-spacer></v-spacer>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Suche"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>
        <v-card-subtitle>
          <span v-if="latestStatus"
            >{{ latestGdprStatus.accepted }} von
            {{ latestGdprStatus.accepted + latestGdprStatus.notAccepted }}
            Benutzer:innen haben bereits zugestimmt. Dies entspricht
            {{ latestGdprStatus.percentage }} %.<br />
            {{ latestGdprStatus.notNeeded }} funktionale Accounts benötigen keine Zustimmung.</span
          >
        </v-card-subtitle>

        <v-card-text>
          <v-autocomplete
            v-model="select"
            :items="items"
            dense
            chips
            small-chips
            label="Solo"
            multiple
            solo
            deletable-chips
          ></v-autocomplete>

          <v-data-table
            :headers="secondHeaders"
            :items="latestGdprStatus.data"
            :search="search"
          ></v-data-table>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
  <v-row v-else>
    <v-col cols="12" md="12">
      <v-card>
        <v-card-title>Datenschutzerklärung hinzufügen</v-card-title>

        <v-card-text>
          <v-form>
            <v-container>
              <v-row>
                <v-col cols="12" md="6">
                  <v-dialog
                    ref="dialog"
                    v-model="modal1"
                    v-model:return-value="newForceDate"
                    persistent
                    width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="newForceDate"
                        label="Zustimmungspflichtsdatum"
                        prepend-icon="mdi-calendar"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                        :disabled="sending"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="newForceDate"
                      :allowed-dates="allowedForceDates"
                      scrollable
                    >
                      <v-spacer></v-spacer>
                      <v-btn text color="primary" @click="modal1 = false"> Cancel </v-btn>
                      <v-btn text color="primary" @click="$refs.dialog.save(newForceDate)">
                        OK
                      </v-btn>
                    </v-date-picker>
                  </v-dialog>
                </v-col>

                <v-col cols="12" md="6">
                  <v-dialog
                    ref="dialog2"
                    v-model="modal2"
                    v-model:return-value="newValidDate"
                    persistent
                    width="290px"
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="newValidDate"
                        label="Gültigkeitsdatum"
                        prepend-icon="mdi-calendar"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                        :disabled="sending"
                      ></v-text-field>
                    </template>
                    <v-date-picker
                      v-model="newValidDate"
                      :allowed-dates="allowedValidDates"
                      scrollable
                    >
                      <v-spacer></v-spacer>
                      <v-btn text color="primary" @click="modal2 = false"> Cancel </v-btn>
                      <v-btn text color="primary" @click="$refs.dialog2.save(newValidDate)">
                        OK
                      </v-btn>
                    </v-date-picker>
                  </v-dialog>
                </v-col>
              </v-row>
              <v-row>
                <v-col cols="12" md="6">
                  <v-textarea outlined v-model="newGdprContent"></v-textarea>
                </v-col>
                <v-col cols="12" md="6"
                  ><GdprDocumentView
                    :content="newGdprContent"
                    :disabled="sending"
                  ></GdprDocumentView
                ></v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>

        <v-card-actions>
          <v-btn :color="util.CONFIG.MAIN_BAR_COLOR" dark tile @click="reset" v-if="!sending">
            <v-icon left>mdi-arrow-left</v-icon> Abbrechen
          </v-btn>
          <v-spacer />
          <v-btn
            :color="util.CONFIG.MAIN_BAR_COLOR"
            :dark="!sending"
            tile
            @click="sendNewGdprDocument"
            :loading="sending"
            :disabled="sending"
            >Anlegen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import Api from '../../LegacyApi';
import * as util from "../../util";
import GdprDocumentView from '../../components/GdprDocumentView.vue';
import { useApplicationStore } from '../../stores/application';

export default {
  components: {
    GdprDocumentView,
  },
  methods: {
    reset: function () {
      this.newGdprContent = '# Neue Datenschutzerklärung\nHier editieren';
      this.editMode = false;
      this.sending = false;

      this.newForceDate = new Date(Date.now() - new Date().getTimezoneOffset() * 60000);
      this.newForceDate.setDate(this.newForceDate.getDate() + 35);
      this.newForceDate = this.newForceDate.toISOString().substr(0, 10);

      this.newValidDate = new Date(Date.now() - new Date().getTimezoneOffset() * 60000);
      this.newValidDate.setDate(this.newValidDate.getDate() + 70);
      this.newValidDate = this.newValidDate.toISOString().substr(0, 10);
    },
    reloadGdprDocuments() {
      this.loading = true;

      Api.defaultHandler(this, Api.getGdpr()).then((result) => {
        this.rawDocuments = result;
        this.documents = result
          .map((item) => {
            return {
              id: item.id,
              creationDate: new Date(Date.parse(item.creationDate)).toLocaleString(),
              validDate: new Date(Date.parse(item.validDate)).toLocaleString(),
              forceDate: new Date(Date.parse(item.forceDate)).toLocaleString(),
              content: item.content,
            };
          })
          .sort((a, b) => b.id - a.id);

        if (this.documents.length > 0) {
          Api.getGdprStatus(this.documents[0].id).then((result) => {
            this.latestStatus = result.map((item) => {
              return {
                ...item,
                accept:
                  item.type === 'ACCEPTED'
                    ? new Date(item.timestamp).toLocaleString()
                    : item.type === 'NOT_NEEDED'
                    ? 'Nicht notwendig'
                    : 'Nicht zugestimmt',
              };
            });
            this.loading = false;
          });
        } else {
          this.loading = false;
        }
      });
    },
    isLatestValid: function () {
      if (this.rawDocuments.length === 0) return true;

      const latestDate = this.rawDocuments.map((a) => new Date(a.validDate));
      const latestValidDate = new Date(Math.max(...latestDate));
      const now = new Date();

      return latestValidDate < now;
    },
    allowedForceDates: function (val) {
      const now = new Date();

      now.setDate(now.getDate() + 30);

      return val >= now.toISOString().substr(0, 10);
    },
    allowedValidDates: function (val) {
      const now = new Date(this.newForceDate);

      now.setDate(now.getDate() + 30);

      return val >= now.toISOString().substr(0, 10);
    },
    sendNewGdprDocument: function () {
      this.sending = true;

      Api.defaultHandler(
        this,
        Api.saveGdpr(
          new Date(this.newForceDate).toISOString(),
          new Date(this.newValidDate).toISOString(),
          this.newGdprContent
        )
      ).then(() => {
        this.reset();
        this.reloadGdprDocuments();
      });
    },
  },
  watch: {
    // whenever question changes, this function will run
    newForceDate: function (newNewForceDate) {
      const minimumValidDate = new Date(newNewForceDate);
      minimumValidDate.setDate(minimumValidDate.getDate() + 30);

      if (minimumValidDate.toISOString().substr(0, 10) > this.newValidDate) {
        this.newValidDate = minimumValidDate.toISOString().substr(0, 10);
      }
    },
  },
  mounted: function () {
    this.reset();
    this.reloadGdprDocuments();
  },
  data() {
    return {
      snackbar: {
        show: false,
        failure: false,
        message: '',
      },
      latestStatus: [],
      documents: [],
      rawDocuments: [],
      loading: true,
      editMode: false,
      newGdprContent: '',
      sending: false,
      newForceDate: '',
      newValidDate: '',
      modal1: false,
      modal2: false,
      search: '',
      select: ['ACCEPTED', 'NOT_ACCEPTED', 'NOT_NEEDED'],
      items: [
        {
          text: 'Akzeptiert',
          value: 'ACCEPTED',
        },
        {
          text: 'Nicht akzeptiert',
          value: 'NOT_ACCEPTED',
        },
        {
          text: 'Nicht notwendig',
          value: 'NOT_NEEDED',
        },
      ],
      applicationStore: useApplicationStore(),
      util,
    };
  },
  computed: {
    headers: () => [
      {
        text: 'Version',
        value: 'id',
      },
      {
        text: 'Veröffentlichungsdatum',
        value: 'creationDate',
      },
      {
        text: 'Zustimmungspflichtsdatum',
        value: 'forceDate',
      },
      {
        text: 'Gültig ab',
        value: 'validDate',
      },
    ],
    secondHeaders: () => [
      {
        text: 'Benutzername',
        value: 'username',
      },
      {
        text: 'Name',
        value: 'fullName',
      },
      {
        text: 'E-Mail',
        value: 'mail',
      },
      {
        text: 'Zustimmung?',
        value: 'accept',
        filterable: false,
      },
    ],
    latestGdpr: function () {
      if (this.documents.length == 0) return null;
      else
        return this.documents.reduce((prev, curr) =>
          new Date(prev.validDate).getTime() > new Date(curr.validDate).getTime() ? prev : curr
        );
    },
    latestGdprStatus: function () {
      const accepted = this.latestStatus.reduce(
        (prev, curr) => (curr.type == 'ACCEPTED' ? prev + 1 : prev),
        0
      );

      const notAccepted = this.latestStatus.reduce(
        (prev, curr) => (curr.type == 'NOT_ACCEPTED' ? prev + 1 : prev),
        0
      );

      const notNeeded = this.latestStatus.reduce(
        (prev, curr) => (curr.type == 'NOT_NEEDED' ? prev + 1 : prev),
        0
      );

      const percentage = ((accepted / (notAccepted + accepted)) * 100).toFixed(2);

      return {
        accepted: accepted,
        notAccepted: notAccepted,
        percentage: percentage,
        notNeeded: notNeeded,
        data: this.latestStatus.filter((item) => this.select.includes(item.type)),
      };
    },
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>
